         PRINT NOGEN
         BEGIN NAME=QXN01,IBM=YES,TPFISOC=YES
***********************************************************************
*          Licensed Materials - Property of IBM                       *
*          "Restricted Materials of IBM"                              *
*          5748-T15                                                   *
*          Copyright IBM Corp. 2005, 2006                             *
*          All Rights Reserved                                        *
*          US Government Users Restricted Rights - Use, duplication   *
*          or disclosure restricted by GSA ADP Schedule Contract      *
*          with IBM Corp.                                             *
***********************************************************************
*  This file is provided on an "as is" basis.  There are no           *
*  warranties, express or implied, including the implied warranties   *
*  of merchantability and fitness for a particular purpose.           *
*  IBM has no obligation to provide service, defect correction, or    *
*  any maintenance for the file.  IBM has no obligation to supply     *
*  any updates or enhancements for the file to you even if such are   *
*  or later become available.                                         *
***********************************************************************
*  Change History                                                     *
*                                                                     *
* 20060911 KN Removed code related to IBMLO as required by            *
*             APAR PJ31330 and to fix compiler errors.                *
*                                                                     *
***********************************************************************
* GENERAL INFORMATION:                                                *
*                                                                     *
* Purpose:   Test macro LODIC SUSPEND,MAXSUSP=reg2,MAXRTN=label       *
* CSO name:  QXN0                                                     *
* Members:   qxn0.cpp, qxn01.asm                                      *
* Called by: QXN5 (CSO)                                               *
* Work Area: EBX012- block type input by user (2 bytes)               *
*                                                                     *
***********************************************************************
         PRLGC ENAME=lodicMacro
LODSUSP  DS    0H
         LA    R1,1          Set Maxsusp time to 1
         LGH   R2,EBX012     Set block type input by user
         CGHI  R2,0          Check block type
         JE    BATC
         CGHI  R2,1
         JE    LOBA
         CGHI  R2,2
         JE    IBMH
         CGHI  R2,4
         JE    USRL1
         CGHI  R2,5
         JE    USRL2
         CGHI  R2,6
         JE    USRL3
         CGHI  R2,7
         JE    USRL4
         CGHI  R2,8
         JE    USRL5
BATC     LODIC SUSPEND,HOLD=YES,AVAIL=ERROR,CLASS=BATCH,MAXSUSP=R1,    X
               MAXRTN=TIMEOUT
         J     NEXTLN
LOBA     LODIC SUSPEND,HOLD=YES,AVAIL=ERROR,CLASS=LOBATCH,MAXSUSP=R1,  X
               MAXRTN=TIMEOUT
         J     NEXTLN
IBMH     LODIC SUSPEND,HOLD=YES,AVAIL=ERROR,CLASS=IBMHI,MAXSUSP=R1,    X
               MAXRTN=TIMEOUT
         J     NEXTLN
USRL1    LODIC SUSPEND,HOLD=YES,AVAIL=ERROR,CLASS=USRLOD1,MAXSUSP=R1,  X
               MAXRTN=TIMEOUT
USRL2    DS    0H
         LA    R1,60
         LODIC SUSPEND,HOLD=YES,AVAIL=ERROR,CLASS=USRLOD1,MAXSUSP=R1,  X
               MAXRTN=TIMEOUT,TIMEINC=SECS
         J     NEXTLN
         PRINT GEN
USRL5    DS    0H
         LA    R1,60   60 SECOND TIMEOUT
         LODIC SUSPEND,HOLD=YES,AVAIL=ERROR,CLASS=USRLOD2,MAXSUSP=R1,  X
               MAXRTN=TIMEOUT,TIMEINC=SECS
         J     NEXTLN
USRL3    LODIC SUSPEND,HOLD=YES,AVAIL=ERROR,CLASS=USRLOD3,MAXSUSP=R1,  X
               MAXRTN=TIMEOUT
         J     NEXTLN
         PRINT NOGEN
USRL4    LODIC SUSPEND,HOLD=YES,AVAIL=ERROR,CLASS=USRLOD4,MAXSUSP=R1,  X
               MAXRTN=TIMEOUT
NEXTLN   WTOPC TEXT='QXN01: DID NOT BRANCH TO MAXRTN, CASE FAILED',    X
               ROUT=PRC,EBROUT=NO
         J     RETLODIC
ERROR    DS    0H              System is not below shutdown levels
         WTOPC TEXT='QXN01: ERROR NOT BELOW LODIC LEVEL',ROUT=PRC,     X
               EBROUT=NO
         J     RETLODIC
*
TIMEOUT  DS    0H              Control goes here after maxsusp reached
         CLI   EBCM01,X'00'    If NOVerbose option
         JE    RETLODIC
         WTOPC TEXT='timeout: GOT CONTROL AFTER GETTING UNSUSPENDED; UNX
               MARK LODIC',ROUT=PRC,EBROUT=NO
RETLODIC DS    0H
         LODIC UNMARK          Unmark the ECB (for lodic_ext() test)
         EPLGC RC=NONE
         LTORG ,
         SPACE 3
         FINIS ,
         END
