/*********************************************************************/
/*      Licensed Materials - Property of IBM                         */
/*      "Restricted Materials of IBM"                                */
/*      5748-T15                                                     */
/*      Copyright IBM Corp. 2005, 2019                               */
/*      All Rights Reserved                                          */
/*      US Government Users Restricted Rights - Use, duplication     */
/*      or dislosure restricted by GSA ADP Schedule Contract         */
/*      with IBM Corp.                                               */
/*********************************************************************/
/* This file is provided on an "as is" basis.  There are no          */
/* warranties, express or implied, including the implied warranties  */
/* of merchantability and fitness for a particular purpose.          */
/* IBM has no obligation to provide service, defect correction, or   */
/* any maintenance for the file.  IBM has no obligation to supply    */
/* any updates or enhancements for the file to you even if such are  */
/* or later become available.                                        */
/*********************************************************************/
/* Change History                                                    */
/*  DEFECT  DATE      DESCRIPTION                                    */
/*  D15680  20080205  Fix for CTLl-6EA (double release of 4KB frame) */
/*  F19211  20090619  Less 4K frame available due to PPA project     */
/*  d26352  20180810  Compiler compatibility updates                 */
/*  d26048  20190115  XWB support                                    */
/*                                                                   */
/*********************************************************************/
/* GENERAL INFORMATION:                                              */
/*                                                                   */
/* Program: QXN3.CPP                                                 */
/*                                                                   */
/* ARGV[1] - The address of a Table for the driver                   */
/*           configuration.                                          */
/* ARGV[2] - The ecb number. Each ECB needs an id.                   */
/*********************************************************************/
#include <slecb.h>                                                              //d26352
#include <tpf/c_decb.h>
#define OWNER 'C'
#define TIMER_OFF 2
#define FRM_ALLOCATION 100

#define PARTITION 925                                                     //f19211
long  bucket[PARTITION];  /* to hold 1000 4k frames */


int reminder = 0;
int loop = PARTITION;
int block_cnt = 0; /* Used to keep a count of the number of 4KB frames */ //f15680
                   /* allocated by a getcc call */
/*
_1block - it is used to chain blocks of resource that will
be allocated. Ie a list of swb, frm, or cmb.
*/

struct     _1kblock *blocks = NULL;
TPF_DECB   *decb=(TPF_DECB *)NULL;
TPF_DECB   *decbn=(TPF_DECB *)NULL;
DECBC_RC   decb_rc;

enum t_getfmt format = (enum t_getfmt)(GETCC_TYPE+GETCC_SIZE+GETCC_COMMON);
enum t_getfmt format_4k = (enum t_getfmt)(GETCC_TYPE);
int main(int argc, char *argv[])
{

	char name_dummy[9];
	char     print_msg[128];

	int ecb_i, pid = 11111111, oldkp, i = 0;
	struct ev0bk pb;
	struct struct_task *childlist;
	char ecb_name[9];
	time_t start_time;
	struct tm *t;
	sysinfo *ECB_TABLE;
	int _argc;
	ECB_TABLE  = (sysinfo *)atol(argv[1]);
	ecb_i      = ECB_TABLE->ecb_no;
	pid       += ecb_i;
	int frm_pid = 0;

	strcpy(ecb_name, "LISHDJR5");
	if (!check_lodic_values())
	{


		if (ECB_TABLE->shutdownlist == LODICSHUTDOWNLEVEL)
		{
			lodic_ext((enum t_lodic_opt)(LODIC_UNMARK),NULL);
			lodic();
			return 0;
		}
	}
	if (ECB_TABLE == NULL)
	{
		/* No heap table. */
		printinfo(ERR_NOHEAP);
		exit(0);
	}

	if (argc == 3)
	{
		frm_pid = atoi(argv[2]);
	}
	_argc = ECB_TABLE->_argc;
	childlist = ECB_TABLE->ecb;
	/* When the system goes to InputShutdown, we want to */
	/* Print out a message after it comes out of it      */
	if (_argc > 3)
	{ /* This child/ECB was sent after we think the system
	  is in input shutdown */

		(void) time(&start_time); /* get current time/date  */
		t = localtime(&start_time);

		sprintf(print_msg, "%s%s%s%d%s%d%s%d%s%s",
			"ECB WAS HELD, TIME IN=",ECB_TABLE->time_in,", OUT=",t->tm_hour, ":",
			t->tm_min,":",t->tm_sec,
			",NOT ENOUGH-",ECB_TABLE->r_sd);

		printinfo(print_msg);


		exit(0); /* We do not need this ecb to stick around */
	}


	/* Use ECB0 for shutdown control */
	/* Prevent every ECB except ECB0 to be marked as been suspended */
	if ((ECB_TABLE->shutdownlist == INPUTLISTSHUTDOWNLEVEL) ||
		(ecb_i>0 && (ECB_TABLE->shutdownlist == LODICSHUTDOWNLEVEL)))
	{


		lodic_ext((enum t_lodic_opt)(LODIC_UNMARK),NULL);


	}

	/* Get a unique name for this ECB  */
	sprintf(ecb_name, "%d",pid);
	ecb_name[0] = ECB_TABLE->shutdownlist;
	ecb_name[8] = '\0';
	pb.evnpstinf.evnbkc1 = 1;

	cinfc(CINFC_WRITE, C_PGM);
	oldkp = ecbp2() -> ce2okey ;
	childlist[ecb_i].running = YES;


	/******************************/
	/* Call allocate resources    */
	/******************************/


	//allocate_resource(childlist, ECB_TABLE, ecb_i, ecb_name);

	ecbp2()->ce2okey = oldkp;
	keyrc();


	if (ECB_TABLE->rra  == FRM )
	{
		int i=0;
		loop = PARTITION;

		reminder = ECB_TABLE->rsize % PARTITION;

		int whichecb = 1;

		if (ECB_TABLE->rsize  > PARTITION)
		{
			whichecb = ECB_TABLE->rsize / PARTITION;
			if (ECB_TABLE->rsize % PARTITION > 0)
			{
				whichecb++;

			}

		}

		if (whichecb == frm_pid) loop = reminder;
		if (loop==0) loop = reminder;


		decb = tpf_decb_create(ecb_name, &decb_rc);

		if (decb_rc == DECBC_OK)
		{

			for (i=0; i < loop; i++)
			{
				if (inputlist_ok(ECB_TABLE, name_dummy)==0)
				{
					break;

				}

				if (ECB_TABLE->request_exit==YES)
				{

					break;
				}
				if (ECB_TABLE->shutdownlist == INPUTLISTSHUTDOWNLEVEL)
				{
					if (INPUTLIST_ok()) {

						break;
					}
				}

				else  if (!check_lodic_values() || INPUTLIST_ok())
				{
					break;
				}

				if (levtest(decb))
					detac_ext(decb, DETAC_NOCHECK);

				if (inputlist_ok(ECB_TABLE, name_dummy)==0)
				{

					break;
				}
				blocks  = (struct _1kblock*)getcc( decb, format_4k, L4, ' ' );
				bucket[i] = (long)blocks;
				block_cnt++; /* number of 4KB frames. Used later to release using relcc */ //f15680

			}


		}
	}

	/**************************************************/
	/* Wait for QXN5  to signal to stop rce           */
	/**************************************************/
	while (childlist && childlist[ecb_i].running == YES)
	{

		if (childlist[0].running == NO) /* new */
		{                               /* new */
			break;                      /* new */
		}                               /* new */

		/* THE ECB reserve to PRINT THE MSG FOR LODIC STATE */
		if ((ecb_i == 0) && (ECB_TABLE->shutdownlist == LODICSHUTDOWNLEVEL))
		{
			/*********************************************************/
			/* Print a message every minute to let                   */
			/* operator knows we are not below  lodic shutdown level */
			/*********************************************************/

			if (lodic())
				/* IF we reached lodic shutdownlevel this ecb will */
				/* give up control. The desire state for this ecb  */
			{

				/* Not below lodic level, print msg */
				printinfo(INFO_MSGL);
				/* wait one minute before printing  msg */
				event_handler(&pb, NULL,60);

			}

		}


		/******************************************************/
		/* THE ECB is reserved to print the msg for inputlist */
		/* shutdown state                                     */
		/******************************************************/
		else if ((ecb_i == 0) &&
			(ECB_TABLE->shutdownlist == INPUTLISTSHUTDOWNLEVEL))
		{
			/*********************************************************/
			/* Print a message every minute to let  operator knows   */
			/* we are not below  inputlisthutdown level              */
			/*********************************************************/

			/* if not in inputshutdown                              */
			/* Start printing msg that we are not in inputshut down */
			/* Print msg only if system is in LODIC shutdown to     */
			/* prevent so many msg floating around                  */

			if (ECB_TABLE->shutdown == INLSHUTD)
				printinfo(INFO_MSGI);

			event_handler(&pb, NULL,60);

		}

		else  event_handler(&pb, NULL,TIMER_OFF);


	} /* while */


    /* Release any 4KB frames allocated by this program */
	if (ECB_TABLE->rra == FRM)
    {
       if (decb_rc == DECBC_OK) {             /* Release any blocks allocated */ //f15680

          if (levtest(decb)) {                /* Release current block in DECB*/
             relcc(decb);                                                        //f15680
             block_cnt--;                                                        //f15680
          }                                                                      //f15680

          for (i=0; i < block_cnt; i++)                                          //f15680
	      {
             attac_ext(decb,ATTAC_USER_DEFAULT);   /* Pop next block         */  //f15680
             relcc(decb);                                                        //f15680
          }
       }                                                                         //f15680
    }

	exit(0);
	return 0;
} /* END MAIN */


